"""esokoni URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.conf.urls.static import static

from django.contrib import admin
from django.urls import path
###from django.urls import path
##from django.urls import url
###
#from django.conf.urls import url
from django.urls import path, include
#from inventory import views
from inventory.views import (
    index,posInv,getSalesToken,sendTokenToTempTokens,
    postNewUoq,sendItemDescToTempSalesDb,removeTempItemDescFromDb,
    uoqList,loadAllPending,getItemUoqAndItemNames,
    getItemUoq,insertPaidAmountToSalesToken,getDataBeforeCloseSalesToken,
    getAllAmountsForASalesToken,
    insertDiscountAmountToSalesToken,
    purchasesList,expensesList,getBatchNumber,removeAmountPaidFromDb,
    stockRequisitionList,closeSalesToken,postNewUser,tryLogin,userPanel,
    postNewPurchases,postNewExpenses,salesList,
    postPurchasesMultiple,
    loadSalesReport008,loadSalesReport009,
    salesReport0088,pnlReport0088,
    salesReport0089,
    loadPNLReport008,
    postUserRoles,
    loadPurchasesReport008,loadPurchasesReport009,purchasesReport0088,purchasesReport0089,
    others,expensesReports,
    loadExpensesReport008,loadExpensesReport009,expensesReport0088,expensesReport0089,
    systemUsers,purchasesReports,stockInToWarehouses,stockInToWarehousesAdv,
    userLoginCategory,
    postUserCategory,
    postCategoryRoles,
    postNewSystemUser,
    warehousesList,shopsList,warehousesInvList,
    postNewWarehouse,
    postNewWarehouseManager,postNewShop,postNewShopManager,
    postNewStockRequisition,postNewCustomer,postNewSupplier,
    postDeleteSales,
    getDataToCreateStockRequisition,
    customersList,suppliersList,postNewPurchasesBatch,
    postNewStockRequisitionMultiple,salesReports,usersList,
    postEditPurchases,postEditSales,
    itemsSalesPriceList,postNewSalesPrice,
    purchasesArchiveList,
    loadPurchasesArchive008,purchasesArchive0088,
    stockBalanceList,
    salesArchiveList,loadSalesArchive008,salesArchive0088,
    stockInToShopsAdv,
    stockInToShopsArchive0088, stockInToWarehousesArchive0088,stockInToShopsReport0088,
    #stockInToShopsReport0088,
    stockInToWarehousesReport0088,
    postDeletePurchases,backUpUOQ,backUpUOQ02,
    backUpInvNoSettings,backUpItems,
    backUpItemBrand,backUpItemSize,backUpItemDesc,
    backUpItemDesc,
    backUpItemMeasures,backUpItemSalesPrice,
    backUpPurchasesDetails,backUpPurchasesStore,
    backUpPurchaseBatch,backUpItemInvNoSettings,
    backUpCountTokens,backUpTempSalesToken,
    backUpTempSalesTokenDetails, backUpTempSalesTokenPaidAmount,
    backUpSupplier,
    backUpAccount,backUpAccountCategory,backUpExpenses,backUpCustomer,
    backUpLoginCategory,backUpUser,backUpUserLoginCategory,backUpUserPassword,
    stockInToShops,postStockInToShopMultiple,postStockInToWarehouseMultiple,
    stockInToShopsArchiveList,stockInToWarehousesArchiveList,
    loadStockInToShopsArchive008,
    postEditStockInToShops,postDeleteStockInToShops,
    postEditStockInToWarehouses,postDeleteStockInToWarehouses,
    postEditSupplier,postDeleteSupplier,postEditShop,postEditWarehouse,
    stockInToShopsReports,stockInToWarehousesReports,
    loadStockInToShopsReport008,loadStockInToWarehousesReport008,
    loadStockInToWarehousesArchive008,
    ####foods
    menusList,postNewMenuCategory,postNewFoodMenu,postEditFoodMenu,
    ###EXT
    itemsCategoryList,postNewItemCategory,
    purchasesListExt,postNewPurchasesExt,
    posInvExt,
    paymentMethodsList,

    ##showimage,
    fileupload,
     addImageToItems,postImageToItemsExt,
    getItemDescsFromItemCategory,
    sampleHtml,
    postNewPaymentMobileNo,
    getMobileNumbersFromSPS,

    ###
    insertPaidAmountToSalesTokenExt,
    smsGenerator,

    ### path('inventory/ordersFromSuppliersExt', ordersFromSuppliersExt),
    postNewOrderExt,
    ordersFromSuppliersExt,passcodeLogin,loadSingleTokenPending,printTest,

    companyRegister,postNewCompany,

)

urlpatterns = [
    path('', include('api.urls')),
    #path('admin/', admin.site.urls),
    #path('inventory/index', index),
    #getItemUoq
    path('inventory/printTest/', printTest),
    path('inventory/uoqList/postNewUoq/', postNewUoq, name = "postNewUoq"),
    path('inventory/purchasesList/getItemUoq/', getItemUoq, name = "getItemUoq"),
    path('inventory/purchasesList/postNewPurchases/', postNewPurchases, name = "postNewPurchases"),
    path('inventory/purchasesList/postPurchasesMultiple/', postPurchasesMultiple, name = "postPurchasesMultiple"),
    path('inventory/purchasesList/postUserCategory/', postUserCategory, name = "postUserCategory"),
    path('inventory/purchasesList/getBatchNumber/', getBatchNumber, name = "getBatchNumber"),
    path('inventory/purchasesList/postDeletePurchases/', postDeletePurchases, name = "postDeletePurchases"),

    #postDeletePurchases
    path('inventory/userLoginCategory/postUserRoles/', postUserRoles, name = "postUserRoles"),
    path('inventory/userLoginCategory/postCategoryRoles/', postCategoryRoles, name = "postCategoryRoles"),
    
    path('inventory/userLoginCategory/postNewSystemUser/', postNewSystemUser, name = "postNewSystemUser"),
    
    path('inventory/userLoginCategory/postNewWarehouse/', postNewWarehouse, name = "postNewWarehouse"),
    path('inventory/userLoginCategory/postNewWarehouseManager/', postNewWarehouseManager, name = "postNewWarehouseManager"),
    path('inventory/userLoginCategory/postNewStockRequisition/', postNewStockRequisition, name = "postNewStockRequisition"),
    path('inventory/stockRequisitionList/getDataToCreateStockRequisition/', getDataToCreateStockRequisition, name = "getDataToCreateStockRequisition"),
    path('inventory/userLoginCategory/postNewCustomer/', postNewCustomer, name = "postNewCustomer"),
    path('inventory/suppliersList/postNewSupplier/', postNewSupplier, name = "postNewSupplier"),

    path('inventory/suppliersList/postEditSupplier/', postEditSupplier, name = "postEditSupplier"),
    path('inventory/suppliersList/postDeleteSupplier/', postDeleteSupplier, name = "postDeleteSupplier"),

    path('inventory/purchasesList/postNewPurchasesBatch/', postNewPurchasesBatch, name = "postNewPurchasesBatch"),

    path('inventory/shopsList/postNewShop/', postNewShop, name = "postNewShop"),
    path('inventory/shopsList/postEditShop/', postEditShop, name = "postEditShop"),

    path('inventory/warehousesInvList/postEditWarehouse/', postEditWarehouse, name = "postEditWarehouse"),

    path('inventory/shopsList/postNewShopManager/', postNewShopManager, name = "postNewShopManager"),
    path('inventory/stockRequisitionList/postNewStockRequisitionMultiple/', postNewStockRequisitionMultiple, name = "postNewStockRequisitionMultiple"),
    path('inventory/purchasesList/postEditPurchases/', postEditPurchases, name = "postEditPurchases"),
    path('inventory/salesList/postEditSales/', postEditSales, name = "postEditSales"),
    path('inventory/salesList/postDeleteSales/', postDeleteSales, name = "postDeleteSales"),
    path('inventory/salesArchiveList/loadSalesArchive008/', loadSalesArchive008, name = "loadSalesArchive008"),
    path('inventory/itemSalesList/postNewSalesPrice/', postNewSalesPrice, name = "postNewSalesPrice"),
    path('inventory/stockInToShopsArchive0088/postEditStockInToShops/', postEditStockInToShops, name = "postEditStockInToShops"),

    path('inventory/stockInToShopsArchive0088/postDeleteStockInToShops/', postDeleteStockInToShops, name = "postDeleteStockInToShops"),

    path('inventory/stockInToWarehousesArchive0088/postEditStockInToWarehouses/', postEditStockInToWarehouses, name = "postEditStockInToWarehouses"),
    path('inventory/stockInToWarehousesArchive0088/postDeleteStockInToWarehouses/', postDeleteStockInToWarehouses, name = "postDeleteStockInToWarehouses"),


    path('inventory/stockInToShops/postStockInToShopMultiple/', postStockInToShopMultiple, name = "postStockInToShopMultiple"),
    path('inventory/stockInToShopsArchiveList/loadStockInToShopsArchive008/', loadStockInToShopsArchive008, name = "loadStockInToShopsArchive008"),

    path('inventory/purchasesArchiveList/loadPurchasesArchive008/', loadPurchasesArchive008, name = "loadPurchasesArchive008"),


    path('inventory/stockInToWarehouses/postStockInToWarehouseMultiple/', postStockInToWarehouseMultiple, name = "postStockInToWarehouseMultiple"),
    #path('inventory/stockInToShopsArchiveList/loadStockInToShopsArchive008/', loadStockInToShopsArchive008, name = "loadStockInToShopsArchive008"),
    path('inventory/stockInToWarehousesArchiveList/loadStockInToWarehousesArchive008/', loadStockInToWarehousesArchive008, name = "loadStockInToWarehousesArchive008"),

    #loadPurchasesArchive008
    #postEditSales
    #path(r'^inventory/posInv/getSalesToken/', getSalesToken, name = "getSalesToken"),



    path('inventory/posInv/getSalesToken/', getSalesToken, name = "getSalesToken"),
    ###getAllAmountsForASalesToken
    path('inventory/posInv/getAllAmountsForASalesToken/', getAllAmountsForASalesToken, name = "getAllAmountsForASalesToken"),
    path('inventory/posInv/sendTokenToTempTokens/', sendTokenToTempTokens, name = "sendTokenToTempTokens"),
    path('inventory/posInv/sendItemDescToTempSalesDb/', sendItemDescToTempSalesDb, name = "sendItemDescToTempSalesDb"),
    path('inventory/posInv/removeTempItemDescFromDb/', removeTempItemDescFromDb, name = "removeTempItemDescFromDb"),
    path('inventory/posInv/loadAllPending/', loadAllPending, name = "loadAllPending"),
    path('inventory/posInv/getItemUoqAndItemNames/', getItemUoqAndItemNames, name = "getItemUoqAndItemNames"),

    path('inventory/posInv/insertPaidAmountToSalesToken/', insertPaidAmountToSalesToken, name = "insertPaidAmountToSalesToken"),

    path('inventory/posInv/removeAmountPaidFromDb/', removeAmountPaidFromDb, name = "removeAmountPaidFromDb"),
    path('inventory/posInv/getDataBeforeCloseSalesToken/', getDataBeforeCloseSalesToken, name = "getDataBeforeCloseSalesToken"),

    path('inventory/posInv/insertDiscountAmountToSalesToken/', insertDiscountAmountToSalesToken, name = "insertDiscountAmountToSalesToken"),

    path('inventory/posInv/closeSalesToken/', closeSalesToken, name = "closeSalesToken"),


    path('inventory/posInv/backUpUOQ/', backUpUOQ, name = "backUpUOQ"),
    path('inventory/posInv/backUpUOQ02/', backUpUOQ02, name = "backUpUOQ02"),
    path('inventory/posInv/backUpInvNoSettings/', backUpInvNoSettings, name = "backUpInvNoSettings"),
    path('inventory/posInv/backUpItems/', backUpItems, name = "backUpItems"),

    path('inventory/posInv/backUpItemBrand/', backUpItemBrand, name = "backUpItemBrand"),
    path('inventory/posInv/backUpItemSize/', backUpItemSize, name = "backUpItemSize"),
    path('inventory/posInv/backUpItemDesc/', backUpItemDesc, name = "backUpItemDesc"),
    path('inventory/posInv/backUpItemInvNoSettings/', backUpItemInvNoSettings, name = "backUpItemInvNoSettings"),

    path('inventory/posInv/backUpItemMeasures/', backUpItemMeasures, name = "backUpItemMeasures"),
    path('inventory/posInv/backUpItemSalesPrice/', backUpItemSalesPrice, name = "backUpItemSalesPrice"),
    path('inventory/posInv/backUpPurchasesDetails/', backUpPurchasesDetails, name = "backUpPurchasesDetails"),
    path('inventory/posInv/backUpPurchasesStore/', backUpPurchasesStore, name = "backUpPurchasesStore"),
    path('inventory/posInv/backUpPurchaseBatch/', backUpPurchaseBatch, name = "backUpPurchaseBatch"),

    path('inventory/posInv/backUpCountTokens/', backUpCountTokens, name = "backUpCountTokens"),
    path('inventory/posInv/backUpTempSalesToken/', backUpTempSalesToken, name = "backUpTempSalesToken"),
    path('inventory/posInv/backUpTempSalesTokenDetails/', backUpTempSalesTokenDetails, name = "backUpTempSalesTokenDetails"),
    path('inventory/posInv/backUpTempSalesTokenPaidAmount/', backUpTempSalesTokenPaidAmount, name = "backUpTempSalesTokenPaidAmount"),
    path('inventory/posInv/backUpSupplier/', backUpSupplier, name = "backUpSupplier"),

    path('inventory/posInv/backUpAccount/', backUpAccount, name = "backUpAccount"),
    path('inventory/posInv/backUpAccountCategory/', backUpAccountCategory, name = "backUpAccountCategory"),
    path('inventory/posInv/backUpExpenses/', backUpExpenses, name = "backUpExpenses"),
    path('inventory/posInv/backUpCustomer/', backUpCustomer, name = "backUpCustomer"),

    path('inventory/posInv/backUpLoginCategory/', backUpLoginCategory, name = "backUpLoginCategory"),
    path('inventory/posInv/backUpUser/', backUpUser, name = "backUpUser"),
    path('inventory/posInv/backUpUserLoginCategory/', backUpUserLoginCategory, name = "backUpUserLoginCategory"),
    path('inventory/posInv/backUpUserPassword/', backUpUserPassword, name = "backUpUserPassword"),
#//backUpLoginCategory();
#//backUpUser();
#//backUpUserLoginCategory();
#//backUpUserPassword();
    #backUpInvNoSettings backUpSupplier
    #backUpUOQ
    path('inventory/expensesList/postNewExpenses/', postNewExpenses, name = "postNewExpenses"),
    path('inventory/expensesList/postNewUser/', postNewUser, name = "postNewUser"),
    path('inventory/index/tryLogin/', tryLogin, name = "tryLogin"),


    #postNewUser
   #removeAmountPaidFromDb  closeSalesToken #loadSalesReport008
   #getDataBeforeCloseSalesToken
     #insertPaidAmountToSalesToken
     #getItemUoqAndItemNames
    #loadAllPending
    #removeTempItemDescFromDb
    #sendItemDescToTempSalesDb
    #sendTokenToTempTokens
    #getSalesToken
    #getBatchNumber #postNewPurchasesBatch
    #getDataToCreateStockRequisition
    #postNewWarehouse
    #postNewStockRequisition
    #postNewSystemUser
    #postUserCategory postUserRoles
    #path('inventory/other', others),
    #usersList userPanel
    path('inventory/index', index),
    path('inventory/userPanel', userPanel),
    path('inventory/posInv/loadSalesReport008/', loadSalesReport008, name = "loadSalesReport008"),
    path('inventory/posInv/loadSalesReport009/', loadSalesReport009, name = "loadSalesReport009"),

    path('inventory/posInv/loadPNLReport008/', loadPNLReport008, name = "loadPNLReport008"),

    path('inventory/posInv/loadPurchasesReport008/', loadPurchasesReport008, name = "loadPurchasesReport008"),
    path('inventory/posInv/loadPurchasesReport009/', loadPurchasesReport009, name = "loadPurchasesReport009"),

    path('inventory/posInv/loadExpensesReport008/', loadExpensesReport008, name = "loadExpensesReport008"),
    path('inventory/posInv/loadExpensesReport009/', loadExpensesReport009, name = "loadExpensesReport009"),


    path('inventory/StockInToShops/loadStockInToShopsReport008', loadStockInToShopsReport008, name='loadStockInToShopsReport008'),

    path('inventory/stockInToWarehousesReports/loadStockInToWarehousesReport008', loadStockInToWarehousesReport008, name='loadStockInToWarehousesReport008'),

    #loadSalesReport009

    #usersList
    path('inventory/purchasesReports', purchasesReports),
    path('inventory/purchasesReport0088', purchasesReport0088, name='purchasesReport0088'),
    path('inventory/purchasesReport0089', purchasesReport0089, name='purchasesReport0089'),
    path('inventory/usersList', usersList),
    path('inventory/expensesList', expensesList),

    #stockInToShopsReport0088
    path('inventory/stockInToShopsReport0088', stockInToShopsReport0088, name='stockInToShopsReport0088'),

    path('inventory/stockInToWarehousesReport0088', stockInToWarehousesReport0088, name='stockInToWarehousesReport0088'),

    path('inventory/salesReport0088', salesReport0088, name='salesReport0088'),
    path('inventory/salesReport0089', salesReport0089, name='salesReport0089'),
    path('inventory/pnlReport0088', pnlReport0088, name='pnlReport0088'),
    path('inventory/salesReports', salesReports),

    #loadStockInToShopsReport008
    path('inventory/stockInToShopsReports', stockInToShopsReports),

    path('inventory/stockInToWarehousesReports', stockInToWarehousesReports),

    path('inventory/expensesReports', expensesReports),
    path('inventory/expensesReport0088', expensesReport0088, name='expensesReport0088'),
    path('inventory/expensesReport0089', expensesReport0089, name='expensesReport0089'),
    path('inventory/uoqList', uoqList),
    path('inventory/purchasesList', purchasesList),
    path('inventory/posInv', posInv),

    path('inventory/systemUsers', systemUsers),

    path('inventory/userLoginCategory', userLoginCategory),
    path('inventory/warehousesList', warehousesList),
    path('inventory/customersList', customersList),
    path('inventory/suppliersList', suppliersList),
    path('inventory/salesList', salesList),
    path('inventory/stockBalanceList', stockBalanceList),
    #stockBalanceList
    path('inventory/itemsSalesPriceList', itemsSalesPriceList),
    path('inventory/salesArchiveList', salesArchiveList),
    path('inventory/salesArchive0088', salesArchive0088),
    path('inventory/purchasesArchiveList', purchasesArchiveList),
    path('inventory/purchasesArchive0088', purchasesArchive0088),


    path('inventory/stockInToShopsArchive0088', stockInToShopsArchive0088),
    #purchasesArchive0088 stockInToShopsArchive0088
    #purchasesArchiveList
    path('inventory/stockInToWarehousesArchive0088', stockInToWarehousesArchive0088),
    path('inventory', stockRequisitionList),
    #salesList
    #path('inventory/stockRequisitionList', stockRequisitionList),
    path('inventory/shopsList', shopsList),
    path('inventory/stockInToShops', stockInToShops),
    path('inventory/stockInToShopsAdv', stockInToShopsAdv),
    path('inventory/stockInToShopsArchiveList', stockInToShopsArchiveList),

    path('inventory/warehousesInvList', warehousesInvList),
    path('inventory/stockInToWarehouses', stockInToWarehouses),
    path('inventory/stockInToWarehousesAdv', stockInToWarehousesAdv),
    path('inventory/stockInToWarehousesArchiveList', stockInToWarehousesArchiveList),
    #expensesList
    #path('inventory/salesReport0088', salesReport0088),
    #stockRequisitionList
    path('inventory/menusList/postNewMenuCategory/', postNewMenuCategory, name = "postNewMenuCategory"),

    path('inventory/menusList/postNewFoodMenu/', postNewFoodMenu, name = "postNewFoodMenu"),
    path('inventory/menusList/postEditFoodMenu/', postEditFoodMenu, name = "postEditFoodMenu"),

    path('inventory/menusList', menusList),

    ###EXT itemsCategoryList
    path('inventory/itemsCategoryList/postNewItemCategory/', postNewItemCategory, name = "postNewItemCategory"),
    path('inventory/purchasesListExt/postNewPurchasesExt/', postNewPurchasesExt, name = "postNewPurchasesExt"),


    path('inventory/itemsCategoryList', itemsCategoryList),

    path('inventory/purchasesListExt', purchasesListExt),
    ###



    ### IMAGE START
    path('inventory/postImageToItemsExt/fileupload', fileupload, name="fileupload"), ###fileupload

    path('inventory/postImageToItemsExt/getItemDescsFromItemCategory', getItemDescsFromItemCategory, name="getItemDescsFromItemCategory"),
    path('inventory/postImageToItemsExt', postImageToItemsExt),

    ###path('inventory/showimage', showimage), fileupload
    path('inventory/addImageToItems', addImageToItems, name="addImageToItems"),
    path('inventory/posInvExt/getMobileNumbersFromSPS', getMobileNumbersFromSPS, name="getMobileNumbersFromSPS"),

    path('inventory/posInvExt/insertPaidAmountToSalesTokenExt/', insertPaidAmountToSalesTokenExt, name = "insertPaidAmountToSalesTokenExt"),
    path('inventory/posInvExt/passcodeLogin/', passcodeLogin, name = "passcodeLogin"),
    path('inventory/posInvExt/loadSingleTokenPending/', loadSingleTokenPending, name = "loadSingleTokenPending"),

    path('inventory/posInvExt', posInvExt),
    path('inventory/sampleHtml', sampleHtml),

    path('inventory/paymentMethodsList/postNewPaymentMobileNo', postNewPaymentMobileNo, name="postNewPaymentMobileNo"),
    path('inventory/paymentMethodsList', paymentMethodsList),

    ### IMAGE END   getMobileNumbersFromSPS
    ##postImagesToItemsExt getItemDescsFromItemCategory   sampleHtml
    path('inventory/smsGenerator', smsGenerator),

    path('inventory/ordersFromSuppliersExt/postNewOrderExt/', postNewOrderExt, name = "postNewOrderExt"),

    path('inventory/ordersFromSuppliersExt', ordersFromSuppliersExt),
    

    path('inventory/companyRegister/postNewCompany/', postNewCompany, name = "postNewCompany"),
    
    path('inventory/companyRegister', companyRegister),

] + static(settings.MEDIA_URL, document_root= settings.MEDIA_ROOT)
###urlpatterns + =
if settings.DEBUG:
        urlpatterns += static(settings.MEDIA_URL,
                              document_root=settings.MEDIA_ROOT)
