
from django.db import models
from django.db.models import Max
from datetime import datetime
from django.utils import formats
#from dbview.models import DbView
#import django_filters
# Create your models here.

class bill_counter(models.Model):
    id = models.BigAutoField(primary_key=True)
    dateandtime=models.CharField(max_length=16)
    quantity=models.IntegerField()
    def __str__(self):
        return self.name




class categories_shop(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)

class category_shop(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)

class company(models.Model):
    id = models.BigAutoField(primary_key=True)
    company_no=models.CharField(max_length=16)
    name=models.CharField(max_length=128)
    email=models.CharField(max_length=128, null=True)
    telephone1=models.CharField(max_length=16)
    telephone2=models.CharField(max_length=16, null=True)
    tin_no=models.CharField(max_length=16, null=True)
    status=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)

class warehouse_inv(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    company=models.ForeignKey(company, on_delete=models.CASCADE, default="", null=True)
    address=models.CharField(max_length=128)
    telephone=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

###warehouse_inv_id=models.ForeignKey(warehouse_inv, on_delete=models.CASCADE, default="", null=True)

class shop(models.Model):
    id = models.BigAutoField(primary_key=True)
    category_shop=models.ForeignKey(category_shop, on_delete=models.CASCADE, default="")
    company=models.ForeignKey(company, on_delete=models.CASCADE)
    name=models.CharField(max_length=64)
    address=models.CharField(max_length=128)
    telephone=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class account_category(models.Model):

    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class account(models.Model):
    id = models.BigAutoField(primary_key=True)
    account_category=models.ForeignKey(account_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)
    bk_status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class expenses(models.Model):
    id = models.BigAutoField(primary_key=True)
    account=models.ForeignKey(account, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    bk_status=models.CharField(max_length=64, default="")
    details=models.CharField(max_length=64, default="")
    trans_date=models.DateTimeField(max_length=64, default="")

    def __str__(self):
        return self.name

class my_expenses(models.Model):
    id = models.BigAutoField(primary_key=True)
    account=models.ForeignKey(account, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    status=models.CharField(max_length=64, default="")
    details=models.CharField(max_length=64, default="")
    trans_date=models.DateTimeField(max_length=64, default="")

    def __str__(self):
        return self.name


class temp_sales_token(models.Model):
    id = models.BigAutoField(primary_key=True)
    sales_token_no=models.CharField(max_length=16)
    tokendateandtime=models.DateTimeField()
    token_status=models.CharField(max_length=32)
    user_open_token=models.CharField(max_length=32)
    user_close_token=models.CharField(max_length=32)
    customer_name=models.CharField(max_length=128, null=True)
    phone_number=models.CharField(max_length=32, null=True)
    shop=models.ForeignKey(shop, on_delete=models.CASCADE, default="")
    company=models.ForeignKey(company, on_delete=models.CASCADE, default="")
    
    def __str__(self):
        return str(self.id)
        ##wulidal huda

class sales_token_counter(models.Model):
    id = models.BigAutoField(primary_key=True)
    tokendate=models.DateTimeField(max_length=64, default="")
    quantity=models.IntegerField()

    def __str__(self):
        return self.name

class count_tokens(models.Model):
    id = models.BigAutoField(primary_key=True)
    tokendate=models.DateTimeField(max_length=64, default="")
    quantity=models.IntegerField()
    company=models.ForeignKey(company, on_delete=models.CASCADE, default="")

    def __str__(self):
        return self.name




class item(models.Model):
    id = models.BigAutoField(primary_key=True)
    company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class item_size(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class item_brand(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class item_desc(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_id= models.ForeignKey(item, on_delete=models.CASCADE)
    item_brand_id= models.ForeignKey(item_brand, on_delete=models.CASCADE)
    item_size_id= models.ForeignKey(item_size, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id



class temp_sales_token_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    item_desc=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    uoq=models.CharField(max_length=32)

    def __str__(self):
        return self.id
#inv_no_settings

class temp_sales_token_paid_amount(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64)
    payment_method=models.CharField(max_length=32)
    payment_no=models.CharField(max_length=16, null=True)

    def __str__(self):
        return self.id


class temp_sales_token_discount_amount(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64)

    def __str__(self):
        return str(self.id)


class inv_no_settings(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class item_inv_no_settings(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_id=models.ForeignKey(item, on_delete=models.CASCADE)
    inv_no_settings_id=models.ForeignKey(inv_no_settings, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id
#qty_measure
class qty_measure(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.name
#qty_measure_datainv
class qty_measure_data(models.Model):
    id = models.BigAutoField(primary_key=True)
    qty_measure_id=models.ForeignKey(qty_measure, on_delete=models.CASCADE)
    units=models.IntegerField()
    status=models.CharField(max_length=64)
    qty_num=models.DecimalField(max_digits=11, decimal_places=2)

    def __str__(self):
        return self.id

#item_measures
class item_measures(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_id=models.ForeignKey(item, on_delete=models.CASCADE)
    qty_measure_id=models.ForeignKey(qty_measure, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)
    def __str__(self):
        return self.id

class t_purchases(models.Model):
    id = models.BigAutoField(primary_key=True)
    date_and_time=models.DateTimeField(max_length=64)
    status=models.CharField(max_length=64)
    batch_no=models.CharField(max_length=64)
    company=models.ForeignKey(company, on_delete=models.CASCADE)

    def __str__(self):
        return self.id

class purchases_store(models.Model):
    id = models.BigAutoField(primary_key=True)
    purchases_id=models.ForeignKey(t_purchases, on_delete=models.CASCADE,null=True)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    unit_price=models.DecimalField(max_digits=11, decimal_places=2)
    status=models.CharField(max_length=64)
    uoq=models.CharField(max_length=64)
    category=models.CharField(max_length=64, null=True)

    def __str__(self):
        return self.id

class purchases_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    purchases_id=models.ForeignKey(t_purchases, on_delete=models.CASCADE)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    unit_price=models.DecimalField(max_digits=11, decimal_places=2)
    status=models.CharField(max_length=64)
    uoq=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class login_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    status=models.CharField(max_length=64)
    name=models.CharField(max_length=64)
    details=models.CharField(max_length=254, default="")

    def __str__(self):
        return self.id

class users(models.Model):
    id = models.BigAutoField(primary_key=True)
    company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    status=models.CharField(max_length=64)
    username=models.CharField(max_length=64)
    useremail=models.EmailField(max_length=128)

    def __str__(self):
        return str(self.id)

class user_password(models.Model):
    id = models.BigAutoField(primary_key=True)
    users=models.ForeignKey(users, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)
    password=models.CharField(max_length=256)
    issue_date=models.DateTimeField(max_length=32)
    expire_date=models.DateTimeField(max_length=32)

    def __str__(self):
        return str(self.id)

class user_sessions(models.Model):
    id = models.BigAutoField(primary_key=True)
    users=models.ForeignKey(users, on_delete=models.CASCADE)
    session_str=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

###user_login_category ###user_login_category
class user_login_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE)
    login_category_id=models.ForeignKey(login_category, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class roles(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    details=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class category_roles(models.Model):
    id = models.BigAutoField(primary_key=True)
    #login_category
    role_id=models.ForeignKey(roles, on_delete=models.CASCADE)
    login_category_id=models.ForeignKey(login_category, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id





class shop_manager(models.Model):
    id = models.BigAutoField(primary_key=True)
    shop_id=models.ForeignKey(shop, on_delete=models.CASCADE)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return self.id

class warehouse(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    address=models.CharField(max_length=128)
    telephone=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class warehouse_manager(models.Model):
    id = models.BigAutoField(primary_key=True)
    warehouse_id=models.ForeignKey(warehouse, on_delete=models.CASCADE)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)
         #sss
class supplier(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=128)
    company=models.ForeignKey(company, on_delete=models.CASCADE, default="")
    email=models.CharField(max_length=128)
    telephone1=models.CharField(max_length=128)
    telephone2=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class customer(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=128)
    email=models.CharField(max_length=128)
    telephone1=models.CharField(max_length=128)
    telephone2=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class stock_requisition(models.Model):
    id = models.BigAutoField(primary_key=True)
    category=models.CharField(max_length=128, default="")
    stock_requisition_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    status=models.CharField(max_length=64, default="")
    origin=models.CharField(max_length=128, default="")
    destination=models.CharField(max_length=128, default="")

    def __str__(self):
        return self.id

class stock_requisition_supplier_from(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    supplier_id=models.ForeignKey(supplier, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_customer_from(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    customer_id=models.ForeignKey(customer, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_warehouse_from(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    warehouse_id=models.ForeignKey(warehouse, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_supplier_to(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    supplier_id=models.ForeignKey(supplier, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_customer_to(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    customer_id=models.ForeignKey(customer, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_warehouse_to(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    warehouse_id=models.ForeignKey(warehouse, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    ###lobster

    def __str__(self):
        return self.id

class stock_in_to_shop_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    shop_id=models.ForeignKey(shop, on_delete=models.CASCADE, default="", null=True)
    stock_in_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    temp_sales_token_details_id=models.ForeignKey(temp_sales_token_details, on_delete=models.CASCADE, default="", null=True)
    ###goggins

    def __str__(self):
        return self.id


class stock_in_to_warehouse_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    warehouse_inv_id=models.ForeignKey(warehouse_inv, on_delete=models.CASCADE, default="", null=True)
    stock_in_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    stock_in_to_shop_details_id=models.ForeignKey(stock_in_to_shop_details, on_delete=models.CASCADE, default="", null=True)
    ###goggins

    def __str__(self):
        return self.id


class stock_balance_warehouse(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_details_id=models.ForeignKey(stock_requisition_details, on_delete=models.CASCADE)
    warehouse_id=models.ForeignKey(warehouse, on_delete=models.CASCADE)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    trans_status=models.CharField(max_length=32, default="")

    def __str__(self):
        return self.id

class batch_count(models.Model):
    id = models.BigAutoField(primary_key=True)
    counter=models.IntegerField()
    batch_year=models.CharField(max_length=32)
    status=models.CharField(max_length=64)
    ##yuu
    def __str__(self):
        return self.id


class item_sales_price(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    price=models.DecimalField(max_digits=11, decimal_places=2)
    status=models.CharField(max_length=64)
    ##wion
    def __str__(self):
        return self.id

class purchase_batch(models.Model):
    id = models.BigAutoField(primary_key=True)
    batch_number=models.CharField(max_length=64, default="")
    supplier_id=models.ForeignKey(supplier, on_delete=models.CASCADE)
    company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    batch_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id
         #sss
class mobile_money_sps(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)

class mobile_money_no(models.Model):
    id = models.BigAutoField(primary_key=True)
    mobile_money_sps=models.ForeignKey(mobile_money_sps, on_delete=models.CASCADE)
    name=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)

class pos_inv_passcode(models.Model):
    id = models.BigAutoField(primary_key=True)
    username=models.CharField(max_length=64, default="")
    passcode=models.CharField(max_length=16, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)




class TestView(models.Model):
    name = models.CharField(max_length=64)
    id = models.BigAutoField(primary_key=True)

    class Meta:
        managed = False
        db_table = "test_view"

class view_v_item_qty_33_1_c(models.Model):
    item_measures_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    qty_measure_id = models.IntegerField()
    qty_measure_name = models.CharField(max_length=64)
    single_unit=models.DecimalField(max_digits=11, decimal_places=2)
    half_unit=models.DecimalField(max_digits=11, decimal_places=2)
    quarter_unit=models.DecimalField(max_digits=11, decimal_places=2)
    company_id=models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_qty_33_1_c"

class view_v_purchases_full_1(models.Model):
    purchases_id = models.BigAutoField(primary_key=True)
    purchases_details_id = models.IntegerField()
    purchases_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    item_desc_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    status = models.CharField(max_length=64)
    uoq = models.CharField(max_length=64)
    unit_price=models.DecimalField(max_digits=11, decimal_places=2)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    total_price=models.DecimalField(max_digits=15, decimal_places=2)   
    company_id = models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_purchases_full_1"


class view_v_item_desc_1(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_desc_1"

class view_v_item_desc_with_uoq_1(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    uoq = models.CharField(max_length=64)
    single_unit = models.IntegerField()
    company_id=models.IntegerField()

    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_desc_with_uoq_1"


class view_v_item_desc_with_uoq_1_and_price(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    uoq = models.CharField(max_length=64)
    single_unit = models.IntegerField()
    sales_price = models.DecimalField(max_digits=9, decimal_places=2)
    company_id=models.IntegerField()

    #amount = models.DecimalField(max_digits=9, decimal_places=2)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_desc_with_uoq_1_and_price"



class view_v_user_login_details_1_a(models.Model):
    users_id = models.BigAutoField(primary_key=True)
    username = models.CharField(max_length=64)
    password = models.CharField(max_length=564)
    category_name = models.CharField(max_length=64)
    useremail=models.EmailField(max_length=64)
    user_login_category_id = models.IntegerField()
    login_category_id = models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_user_login_details_1_a"
#v_user_login_details_1_a



class view_v_all_expenses_1(models.Model):
    #as expenses_id, b. id as account_id, b.name account_name, amount, trans_date,details,status

    expenses_id = models.BigAutoField(primary_key=True)
    account_id=models.IntegerField()
    account_name = models.CharField(max_length=64)
    amount = models.DecimalField(max_digits=9, decimal_places=2)
    trans_date = models.DateTimeField(max_length=64)
    details = models.CharField(max_length=128)
    status = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_expenses_1"



class view_v_all_expenses_full_1(models.Model):
    #as expenses_id, b. id as account_id, b.name account_name, amount, trans_date,details,status

    expenses_id = models.BigAutoField(primary_key=True)
    account_id=models.IntegerField()
    account_name = models.CharField(max_length=64)
    category_name = models.CharField(max_length=64)
    amount = models.DecimalField(max_digits=9, decimal_places=2)
    trans_date = models.DateTimeField(max_length=64)
    details = models.CharField(max_length=128)
    status = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_expenses_full_1"

class view_v_all_accounts_full_1(models.Model):

    account_id = models.BigAutoField(primary_key=True)
    account_name = models.CharField(max_length=64)
    category_name = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_accounts_full_1"


class view_v_all_sales_tokens_1(models.Model):
    token_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_sales_tokens_1"



class view_v_all_sales_tokens_1_a(models.Model):
    token_details_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    single_unit=models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_sales_tokens_1_a"



class view_v_item_sales_price_1(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    price = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_sales_price_1"



class view_v_item_sales_price_1_a(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    price = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_sales_price_1_a"


class viewv_purchases_store_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=128)
    company_id=models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_purchases_store_balance_1_b"

class view_v_all_stock_in_to_shops_1_a(models.Model):
    sits_id = models.BigAutoField(primary_key=True)
    quantity = models.DecimalField(max_digits=11, decimal_places=2)
    shop_id = models.IntegerField()
    item_desc_id=models.IntegerField()
    single_unit=models.IntegerField()
    desc_name = models.CharField(max_length=256)
    shop_name = models.CharField(max_length=64)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=32)
    stock_in_date = models.DateTimeField(max_length=64)
    company_id = models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_stock_in_to_shops_1_a"

# a.id as sits_id,b.desc_name as desc_name, quantity,uoq,

class view_v_all_stock_in_to_warehouses_1_a(models.Model):
    sits_id = models.BigAutoField(primary_key=True)
    quantity = models.DecimalField(max_digits=11, decimal_places=2)
    warehouse_id = models.IntegerField()
    item_desc_id=models.IntegerField()
    single_unit=models.IntegerField()
    desc_name = models.CharField(max_length=256)
    warehouse_name = models.CharField(max_length=64)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=32)
    stock_in_date = models.DateTimeField(max_length=64)
    company_id = models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_stock_in_to_warehouses_1_a"

# a.status,a.item_desc_id_id as item_desc_id,a.shop_id_id as shop_id,c.name as shop_name

class viewv_stock_in_to_shop_details_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=64)
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    company_id=models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_stock_in_to_shop_details_balance_1_b"


class view_v_stock_in_to_shop_details_balance_1_c(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    ext_category_id=models.IntegerField()
    category_name = models.CharField(max_length=64)
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=64)
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    sales_price=models.DecimalField(max_digits=11, decimal_places=2)
    #id = models.BigAutoField(primary_key=True) HIVYO
    class Meta:
        managed = False
        db_table = "v_stock_in_to_shop_details_balance_1_c"


class view_v_temp_sales_token_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    sales_token_no=models.CharField(max_length=16)
    tokendateandtime=models.DateTimeField()
    token_status=models.CharField(max_length=32)
    user_open_token=models.CharField(max_length=32)
    user_close_token=models.CharField(max_length=32)
    shop_id=models.IntegerField()
    shop_name=models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_1_a"
        ##wulidal huda

class view_v_images_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    name=models.CharField(max_length=256)
    img=models.CharField(max_length=128)

    class Meta:
        managed = False
        db_table = "v_images_1_a"
        ##wulidal huda

class view_v_temp_sales_token_details_1_a(models.Model):
    token_details_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    single_unit=models.IntegerField()
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    item_name = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_1_a"



class view_v_temp_sales_token_details_1_b(models.Model):
    temp_sales_token_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    ###tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    ##single_unit=models.IntegerField()
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    item_name = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_1_b"



class view_v_item_sales_price_1_c(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    uoq = models.CharField(max_length=64)
    single_unit=models.IntegerField()
    #item_desc_id=models.IntegerField()
    price = models.DecimalField(max_digits=9, decimal_places=2)
    status = models.CharField(max_length=64)

    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_sales_price_1_c"

###v_tokens_with_driver_details_1_a
class view_v_stock_in_to_warehouse_details_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=128)
    warehouse_id=models.IntegerField()
    warehouse_name = models.CharField(max_length=128)
    company_id=models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_stock_in_to_warehouse_details_balance_1_b"

##########


class view_v_all_items_sold_in_units_v_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id = models.IntegerField()
    temp_sales_token_id = models.IntegerField()
    uoq = models.CharField(max_length=64)
    quantity = models.DecimalField(max_digits=9, decimal_places=2)
    unit_price = models.DecimalField(max_digits=11, decimal_places=2)
    sales_token_no = models.CharField(max_length=64)
    #desc_name = models.CharField(max_length=256)
    shop_name = models.CharField(max_length=256)
    qty_units = models.DecimalField(max_digits=9, decimal_places=2)
    tokendateandtime = models.DateTimeField(max_length=64, default="")
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_items_sold_in_units_v_1_a"


###v_tokens_with_driver_details_1_a
class view_v_purchases_unit_price_unit_v_1_b(models.Model):
    item_id = models.BigAutoField(primary_key=True)
    item_desc_id = models.IntegerField()
    single_unit=models.IntegerField()
    unit_price_unit = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    uoq_p = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_purchases_unit_price_unit_v_1_b"

##########


class view_v_all_discounts_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    trans_date = models.DateTimeField(max_length=64, default="")
    amount = models.DecimalField(max_digits=11, decimal_places=2)
    shop_name = models.CharField(max_length=256)
    temp_sales_token_id=models.IntegerField()

    class Meta:
        managed = False
        db_table = "v_all_discounts_1_a"

##########


############FOODS START
class food_menu_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

#account_category=models.ForeignKey(account_category, on_delete=models.CASCADE)
class food_menu(models.Model):
    id = models.BigAutoField(primary_key=True)
    food_menu_category=models.ForeignKey(food_menu_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class food_menu_price(models.Model):
    id = models.BigAutoField(primary_key=True)
    food_menu=models.ForeignKey(food_menu, on_delete=models.CASCADE)
    price=models.DecimalField(max_digits=9, decimal_places=2)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

##########


class view_v_food_price_1_a(models.Model):
    price_id = models.BigAutoField(primary_key=True)
    category_id = models.IntegerField()
    menu_id = models.IntegerField()
    price = models.DecimalField(max_digits=11, decimal_places=2)
    category_name = models.CharField(max_length=256)
    menu_name = models.CharField(max_length=256)

    class Meta:
        managed = False
        db_table = "v_food_price_1_a"

##########


############ FOODS END


##########3 EXT START

class ext_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class item_ext_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    ext_category=models.ForeignKey(ext_category, on_delete=models.CASCADE)
    item=models.ForeignKey(item, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class item_desc_ext_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    ext_category=models.ForeignKey(ext_category, on_delete=models.CASCADE)
    item_desc=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

##########3 EXT END

################# IMG START
class order_from_supplier(models.Model):
    id = models.BigAutoField(primary_key=True)
    supplier=models.ForeignKey(supplier, on_delete=models.CASCADE)
    order_date= models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    item=models.ForeignKey(item, on_delete=models.CASCADE)
    item_desc_ext_category=models.ForeignKey(item_desc_ext_category, on_delete=models.CASCADE)###item_ext_category
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    price=models.DecimalField(max_digits=11, decimal_places=2)
    delivery_expecting_date=models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    received_date=models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    uoq=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return str(self.id)

class Image(models.Model):
    id = models.BigAutoField(primary_key=True)
    name= models.CharField(max_length=500)

    img = models.ImageField(upload_to='images/', default=None)
    item_desc= models.ForeignKey(item_desc, on_delete=models.CASCADE, default="")
    ###STEVE NICOL

    def __str__(self):
        return self.name ###+ ": " + str(self.img)



class view_v_item_desc_with_ext_category_01(models.Model):
    idec_id = models.BigAutoField(primary_key=True)
    item_desc_id = models.IntegerField()
    item_id=models.IntegerField()
    category_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_desc_with_ext_category_01"


################# IMG END
class view_v_order_from_suppliers_1_a(models.Model):
    order_id = models.BigAutoField(primary_key=True)
    idec_id =  models.IntegerField()
    item_desc_id = models.IntegerField()
    #item_id=models.IntegerField()
    category_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    order_date = models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    price=models.DecimalField(max_digits=11, decimal_places=2)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=64)
    received_date = models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    #id = models.BigAutoField(primary_key=True) received_date=models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    class Meta:
        managed = False
        db_table = "v_order_from_suppliers_1_a"

###

class view_v_shops_1_a(models.Model):
    shop_id = models.BigAutoField(primary_key=True)
    category_shop_id =  models.IntegerField()
    shop_name = models.CharField(max_length=64)
    #item_id=models.IntegerField()
    category_name = models.CharField(max_length=64)
    address = models.CharField(max_length=128)
    telephone = models.CharField(max_length=16)
    status = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True) received_date=models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    class Meta:
        managed = False
        db_table = "v_shops_1_a"


######################EXT 

class view_v_item_qty_33_1_c_ext(models.Model):
    item_measures_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    company_id=models.IntegerField()
    company_name = models.CharField(max_length=128)
    qty_measure_id = models.IntegerField()
    qty_measure_name = models.CharField(max_length=64)
    single_unit=models.DecimalField(max_digits=11, decimal_places=2)
    half_unit=models.DecimalField(max_digits=11, decimal_places=2)
    quarter_unit=models.DecimalField(max_digits=11, decimal_places=2)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_qty_33_1_c_ext"

######################EXT